CT_PORT EQU 006H
A_PORT EQU  000H
DATA SEGMENT
    LED DB 09H,0AH,24H,14H
    TIME DB 00H
DATA ENDS
STACK SEGMENT 'STACK'
    DW 50 DUP(?)
    TOP LABEL WORD
STACK ENDS
CODE SEGMENT
    ASSUME CS:CODE,DS:DATA,SS:STACK
START:
    MOV AX,DATA
    MOV DS,AX
    MOV AX,STACK
    MOV SS,AX
    MOV SP,TOP
    MOV AL,80H
    MOV DX,CT_PORT
    OUT DX,AL
    MOV AL,0CH          ;óʼ״̬ 
    MOV DX,A_PORT
    OUT DX,AL
    CALL DELAY
    MOV BX,OFFSET LED    ;ѯ״̬ 
NEXT0:
    MOV AL, TIME
    XLAT
    MOV DX,A_PORT
    OUT DX,AL 
    CALL DELAY
    CALL FLASH
    INC TIME
    CMP TIME,4
    JZ  RESET
    JMP NEXT0 
RESET:
    MOV TIME,0
    JMP NEXT0
DELAY PROC NEAR
    PUSH BX
    PUSH CX
    MOV BX,100
NEXT1:
    MOV CX,1000
    LOOP $
    DEC BX
    JNZ NEXT1
    POP CX
    POP BX
    RET
DELAY ENDP 
DELAY0 PROC NEAR
    PUSH BX
    PUSH CX
    MOV BX,10
NEXT4:
    MOV CX,1000
    LOOP $
    DEC BX
    JNZ NEXT4
    POP CX
    POP BX
    RET
DELAY0 ENDP
FLASH PROC NEAR
    PUSH AX
    PUSH CX
    MOV CX,10
    TEST AL,01H
    JNZ CASE1 
    NEXT2:
    TEST AL,20H
    JNZ CASE2 
    NEXT3:
    POP CX
    POP AX 
    RET 
CASE1:
    MOV DX,A_PORT 
    CASE1NEXT:
    XOR AL,01H
    OUT DX,AL 
    CALL DELAY0
    LOOP CASE1NEXT
    JMP NEXT2 
CASE2:
    MOV DX,A_PORT 
    CASE2NEXT:
    XOR AL,20H
    OUT DX,AL 
    CALL DELAY0
    LOOP CASE2NEXT
    JMP NEXT3 
FLASH ENDP
CODE ENDS 
END START